unit io_unit;

{
  for compatibility  *.sdk file format is used

  field options must be repainted after loading
}

interface

uses sysutils;

procedure OpenGame(var cc : byte);
procedure SaveGame(var cc : byte);
function loadfromP1 : boolean;

var iomessage : string;

implementation

uses unit1,game_unit;

type TNumber = record
                nr  : byte;
                org : boolean;
               end;
     TSudoku = array[1..9,1..9] of TNumber;

const leader = 'Sudoku-Kraker : ';

var FSudoku : file of TSudoku;
    IOBoard : TSudoku;

procedure saveGame(var cc : byte);
//save *.sdk file
var s : string;
    i,j : byte;
begin
 for j := 1 to 9 do
  for i := 1 to 9 do
   with game[i,j] do
    begin
     ioboard[i,j].nr := move;
     if move = 0 then ioboard[i,j].org := false
      else ioboard[i,j].org := (mt = mtOrg);
   end;
//
 with form1.Savedialog1 do
  begin
   cc := 0;
   title := 'spel opslaan';
   initialDir := paramstr(0);
   defaultext := 'sdk';
   filter := 'SUDOKU file (*sdk)|*sdk';
   if execute then
    begin
     cc := 1;
     try
      try
       assignfile(fsudoku,filename);
       rewrite(fsudoku);
       write(fsudoku,ioboard);
      except
       cc := 2;
      end;
     finally
      closefile(fsudoku);
     end;
     s := extractfilename(form1.savedialog1.filename);
     iomessage := s;
    end;
  end;//with
end;

procedure OpenGame(var cc : byte);
//load *.sdk file
var s : string;
    i,j : byte;
begin
 cc := 0;
 with form1 do with Opendialog1 do
  begin
   title := 'spel openen';
   initialDir := paramstr(0);
   filter := 'SUDOKU file (*sdk)|*sdk';
   if execute then
    begin
     cc := 1;
     try
      try
       assignfile(fsudoku,filename);
       reset(fsudoku);
       read(fsudoku,ioboard);
      except
       cc := 2; //read error
      end
     finally
      closefile(fsudoku);
     end;
//
     s := extractfilename(form1.opendialog1.filename);
     caption := leader + s;
     iomessage := s;
     for j := 1 to 9 do
      for i := 1 to 9 do
       with ioboard[i,j] do
        begin
         game[i,j].move := nr;
         if nr = 0 then game[i,j].mt := mtFree
          else if org then game[i,j].mt := mtOrg
                else game[i,j].mt := mtPlay;
        end;
    end;//if execute
  end;//with
end;

//----check for *.sdk file

function LoadFromP1 : boolean;
var s : string;
    i,j : byte;
begin
 result := false;
 if paramCount < 1 then exit;
//
 s := paramstr(1);
 if s <> '' then
  try
   assignfile(fsudoku,s);
   reset(fsudoku);
   read(fsudoku,ioboard);
   result := true;
  finally
   closefile(fsudoku);
  end;
//
 if result then
  begin
   iomessage := extractfilename(s);
   for i :=1 to 9 do
    for j := 1 to 9 do
     with ioboard[i,j] do
      begin
       game[i,j].move := nr;
       if nr = 0 then game[i,j].mt := mtFree
        else if org then game[i,j].mt := mtOrg
               else game[i,j].mt := mtPlay;
     end;
  end;//if OK
end;

end.
